/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleAdsControllerActionCustomerClientRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleAdsControllerActionCustomerClientRequest{}

// GoogleAdsControllerActionCustomerClientRequest struct for GoogleAdsControllerActionCustomerClientRequest
type GoogleAdsControllerActionCustomerClientRequest struct {
	OAuthId    *string `json:"oAuthId,omitempty"`
	CustomerId *string `json:"customerId,omitempty"`
}

// NewGoogleAdsControllerActionCustomerClientRequest instantiates a new GoogleAdsControllerActionCustomerClientRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleAdsControllerActionCustomerClientRequest() *GoogleAdsControllerActionCustomerClientRequest {
	this := GoogleAdsControllerActionCustomerClientRequest{}
	return &this
}

// NewGoogleAdsControllerActionCustomerClientRequestWithDefaults instantiates a new GoogleAdsControllerActionCustomerClientRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleAdsControllerActionCustomerClientRequestWithDefaults() *GoogleAdsControllerActionCustomerClientRequest {
	this := GoogleAdsControllerActionCustomerClientRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleAdsControllerActionCustomerClientRequest) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsControllerActionCustomerClientRequest) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleAdsControllerActionCustomerClientRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *GoogleAdsControllerActionCustomerClientRequest) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetCustomerId returns the CustomerId field value if set, zero value otherwise.
func (o *GoogleAdsControllerActionCustomerClientRequest) GetCustomerId() string {
	if o == nil || IsNil(o.CustomerId) {
		var ret string
		return ret
	}
	return *o.CustomerId
}

// GetCustomerIdOk returns a tuple with the CustomerId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleAdsControllerActionCustomerClientRequest) GetCustomerIdOk() (*string, bool) {
	if o == nil || IsNil(o.CustomerId) {
		return nil, false
	}
	return o.CustomerId, true
}

// HasCustomerId returns a boolean if a field has been set.
func (o *GoogleAdsControllerActionCustomerClientRequest) HasCustomerId() bool {
	if o != nil && !IsNil(o.CustomerId) {
		return true
	}

	return false
}

// SetCustomerId gets a reference to the given string and assigns it to the CustomerId field.
func (o *GoogleAdsControllerActionCustomerClientRequest) SetCustomerId(v string) {
	o.CustomerId = &v
}

func (o GoogleAdsControllerActionCustomerClientRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleAdsControllerActionCustomerClientRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.CustomerId) {
		toSerialize["customerId"] = o.CustomerId
	}
	return toSerialize, nil
}

type NullableGoogleAdsControllerActionCustomerClientRequest struct {
	value *GoogleAdsControllerActionCustomerClientRequest
	isSet bool
}

func (v NullableGoogleAdsControllerActionCustomerClientRequest) Get() *GoogleAdsControllerActionCustomerClientRequest {
	return v.value
}

func (v *NullableGoogleAdsControllerActionCustomerClientRequest) Set(val *GoogleAdsControllerActionCustomerClientRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleAdsControllerActionCustomerClientRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleAdsControllerActionCustomerClientRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleAdsControllerActionCustomerClientRequest(val *GoogleAdsControllerActionCustomerClientRequest) *NullableGoogleAdsControllerActionCustomerClientRequest {
	return &NullableGoogleAdsControllerActionCustomerClientRequest{value: val, isSet: true}
}

func (v NullableGoogleAdsControllerActionCustomerClientRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleAdsControllerActionCustomerClientRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
